############nacteni dat
# data TUI - burza cennych papiru od. 3.1.2000 do 14.5.2002
tui<-read.table("tui.dat",header=TRUE)
# pivo - mesicni produkce piva v Australii od ledna 1956 do srpna 1995
beer<-read.table("bier.dat",header=TRUE)



########################################################################
#ukazky casovych rad
plot(Nile) # Flow of the River Nile
plot(AirPassengers ) #Monthly Airline Passenger Numbers 1949-1960
#plot(sunspot.month) #Monthly Sunspot Data, 1749-1997
plot(sunspot.year) #Yearly Sunspot Data, 1700-1988
# Body Temperature Series of Two Beavers (bobri)
plot(beaver1$temp~beaver1$time,col=beaver1$day+1)
plot(beaver1$temp~beaver1$time,col=beaver1$activ+1)
plot(beaver2$temp~beaver2$time,col=beaver2$day+1)
plot(beaver2$temp~beaver2$time,col=beaver2$activ+1)

####################################
decompose(AirPassengers, type="multiplicative")
#######################################################################
# cas rada - vizualizace
plot(tui[,4], type="l", lwd=2, col="red", xlab="time", ylab="closing values", main="TUI AG", ylim=c(0,60) )
plot(diff(log(tui[,4])),type="l")
hist(diff(tui[,4]),prob=T,ylim=c(0,0.6),xlim=c(-5,5),col="red")
lines(density(diff(tui[,4])),lwd=2)
mu<-mean(diff(tui[,4]))
sigma<-sd(diff(tui[,4]))
x<-seq(-4,4,length=100)
y<-dnorm(x,mu,sigma)
lines(x,y,lwd=2,col="blue")
qqnorm(diff(tui[,4]))
abline(0,1)

# Linearni filtry

library(ts)
plot(tui[,4],type="l")
tui.1 <- filter(tui[,4],filter=rep(1/5,5))   # tydenni
tui.2 <- filter(tui[,4],filter=rep(1/25,25))  # mesicni
tui.3 <- filter(tui[,4],filter=rep(1/81,81))  #kvartalni prumery hodnot
lines(tui.1,col="red")
lines(tui.2,col="purple")
lines(tui.3,col="blue")

# Dekompozice CR
#beer1<-beer
beer<-ts(beer[,1],start=1956,freq=12)
plot(stl(log(beer),s.window="periodic"))


#Regresni analyza
#lbeer1<-log(beer1)
lbeer<-log(beer)
t<-seq(1956,1995.2,length=length(beer))
t2<-t^2
plot(lbeer)

# Kvadraticky model
lm(lbeer~t+t2)
lines(lm(lbeer~t+t2)$fit~t,col=2,lwd=2)
# Rozsireny model
lbeer<-log(beer)
t<-seq(1956,1995.2,length=length(beer))
t2<-t^2
sin.t<-sin(2*pi*t)
cos.t<-cos(2*pi*t)
plot(lbeer)
lines(lm(lbeer~t+t2+sin.t+cos.t)$fit~t,col=4) 
summary(lm(lbeer~t+t2+sin.t+cos.t))



# Exponencialni vyhlazovani
beer<-read.csv("C:/beer.csv",header=T,dec=",",sep=";")
beer<-ts(beer[,1],start=1956,freq=12)
HoltWinters(beer)    # typ exponencialniho vyrovnavani, ktere umi podchytit a modelovat sezonnost
plot(beer)
lines(HoltWinters(beer)$fitted[,1],col="red")

#predikce
beer.hw<-HoltWinters(beer)
predict(beer.hw,n.ahead=12)
plot(beer,xlim=c(1956,1999))
lines(predict(beer.hw,n.ahead=48),col=2)


#ARIMA modely - simulace - autokorelacni funkce
sim.ar<-arima.sim(list(ar=c(0.4,0.4)),n=1000)    #simulace AR(2)
sim.ma<-arima.sim(list(ma=c(0.6,-0.4)),n=1000)  #simulace MA(2)
plot(sim.ar)
plot(sim.ma)
#par(mfrow=c(2,2))
acf(sim.ar,main="ACF of AR(2) process")    # autokorelacni funkce, ve forme korelogramu
acf(sim.ma,main="ACF of MA(2) process")  # MA 2 -> pro k>2 je hodota autokoerl fce 0
pacf(sim.ar,main="PACF of AR(2) process")
pacf(sim.ma,main="PACF of MA(2) process")


# ARIMA - priklad
data(LakeHuron)  # Level of Lake Huron 1875-1972
fit<-arima(LakeHuron,order=c(1,0,1))
tsdiag(fit)

Box.test(fit$residuals,lag=1)
LH.pred<-predict(fit,n.ahead=8)
plot(LakeHuron,xlim=c(1875,1980),ylim=c(575,584))
LH.pred<-predict(fit,n.ahead=8)
lines(LH.pred$pred,col="red")
lines(LH.pred$pred+2*LH.pred$se,col="red",lty=3)
lines(LH.pred$pred-2*LH.pred$se,col="red",lty=3)

##################################################
sunspot.year.ts<-ts(sunspot.year,start=1749,freq=11)
acf(sunspot.year.ts,main="Sezonni slozka")
x<-rnorm(1000,0,1)
acf(x,main="Bily sum")
acf(LakeHuron)
#pacf(AirPassengers)

###############################periodogram #########
spectrum(ldeaths)
spectrum(ldeaths, spans = c(3,5))
spectrum(ldeaths, spans = c(5,7))
spectrum(mdeaths, spans = c(3,3))
spectrum(fdeaths, spans = c(3,3))


spectrum(x)  #nahodna cisla
spectrum(x,spans=c(3,5))  #nahodna cisla

spectrum(LakeHuron ,spans=c(3,5))  #nahodna cisla s trendem?
spectrum(sunspot.year,spans=c(3,5)) #1/11=0.0909
#spectrum(AirPassengers, spans=c(3,5))





